import Router from 'vue-router';
const originalPush = Router.prototype.push;
Router.prototype.push = function push(location) {
  return originalPush.call(this, location).catch(err => err);
};

// 对外暴露的router   不能用变量作为路径的
const baseFormWalletWebRouters = [
  {
    path: '/mywallet-page',
    name: 'mywallet-page',
    component: () => import('./views/wallet/index.vue'),
    meta: {
      title: ['我的票夹', '我的票夹'],
      csswrap: 'form-wallet-web',
      single: true
    }
  }
];

const routers = [...baseFormWalletWebRouters,
//   {
//   path: '/',
//   name: 'mywallet-page',
//     component: () => import('./views/wallet/index.vue'),
//     meta: {
//       title: ['我的票夹', '我的票夹'],
//       single: true
//     }
// },
  {
    path: '/',
    meta: {},
    redirect: {
      name: 'home'
    }
  },
  {
    path: '/home',
    name: 'home',
    component: () => import('./views/home/Home.vue'),
    meta: {
      title: ['首页', '首页']
    }
  },
  {
    path: '/login',
    name: 'login',
    component: () => import('./views/login/Login.vue'),
    meta: {
      title: ['登录', '登录'],
      single: false
    }
  }];
baseFormWalletWebRouters.forEach(item => {
  item.meta.cssWrap = 'form-wallet-web';
});
export {
  routers,
  baseFormWalletWebRouters
};
