import { util as utilCn } from 'ems-components-new'
import qs from 'qs';
import accounting from "accounting"
import { queryProcessInfoByClaimNo } from "@/api/server.js";

const util = { ...utilCn }

util.simDeepCopy = function (obj) {
  return JSON.parse(JSON.stringify(obj))
}

util.randomId = function () {
  return new Date().getTime() + '' + parseInt(Math.random() * 10000)
}

// 给对象加上randomId,字段默认为rid，改方法直接修改对象
util.addRandomId = function (items = {}, rid = "rid") {
  if (!items.length) {
    // 如果传入的是单个对象
    items[rid] = util.randomId()
  } else {
    // 如果是数组对象
    items.map(item => item[rid] = util.randomId())
  }
  return items
}

util.getUrlParams = function (url) {
  const uri = url || location.href
  let searchStr = uri.split('?')[1];
  let result = {};
  if (!searchStr) {
    return result;
  } else {
    return qs.parse(searchStr);
  }
};

util.isString = function (str) {
  return Object.prototype.toString.call(str) === "[object, String]"
}

util.isObject = function (obj) {
  return Object.prototype.toString.call(obj) === "[object, Object]"
}

util.isArray = function isArray(arr) {
  if (typeof Array.isArray === 'function') {
    return Array.isArray(arr);
  }

  return toStr.call(arr) === '[object Array]';
};


// 银行账号加 ***
util.formatAccountNo = function (accountNo) {
  if (!accountNo) {
    return;
  }
  return String(accountNo).replace(/^(.{3}).+(.{4})$/g, "$1****$2");
}

// 日期转换为毫秒
util.formatDateToMilSec = function (date) {
  if (!date) {
    return;
  }
  return new Date(date).getTime();
}

// 日期转换为秒
util.formatDateToSec = function (date) {
  return parseInt(util.formatDateToMilSec(date) / 1000);
}

// 打开新页面的方法
util.openTask = function (data) {
  // if (!server) {
  //   return;
  // }
  // queryProcessInfoByClaimNo({
  //   claimNo: data.relClaimNo
  // })
  //   .then(response => {
  //     let dataResult = response.list[0];
  //     dataResult.actionType = 'done';
  //     if (data.isSubmit) {
  //       dataResult.source = 'other';
  //       dataResult.isSubmit = data.isSubmit;
  //     }
  //     util.openTaskFromBillOfAccount(dataResult);
  //   })
  //   .catch(error => { });
}

// 打开新页面用到的方法
util.openTaskFromBillOfAccount = function (data) {
  let singlePage = 'NO';
  let pageName = '';
  let origin = util.getOrigin();
  // let origin = '';
  // if(location.origin != location.href.split('/#')[0]){
  //   origin = location.href.split('/#')[0];
  // }else{
  //   origin = location.origin;
  // }
  let url = "";
  let startUserCode = "";
  let currentNodeName = data.currentTaskName;
  let taskDefinitionKey = data.actID;
  let currentTaskId = "";

  // 获取跳转URL
  url = data.taskLocalVariables[0].url;
  if (url) {
    let tr = url.split("?")[0];
    let tp = "create-payment-apply";
    if (!tr) {
      url = tp + url
    }
    url = origin + '/' + url;
  } else {
    $app.$Message.error('该条数据无跳转的URL参数');
    return;
  }
  startUserCode = data.processVariables[0].procStartUserLdapId;

  // 获取当前节点taskId
  currentTaskId = data.currentTaskID;

  pageName = "employee-other-fee";
  if (pageName == 'payment-plan') {
    pageName = 'create-payment-apply';
  }
  //gl
  if (pageName == 'payment-plan-gl') {
    pageName = 'create-payment-apply';
  }
  //pegeName = url.split("?")[1].split('&')[0].split('=')[1]
  if (data.tpcode) {
    pageName = data.tpcode
  }
  let urlParams = url.split("?")[1].replace("/", "&")
  url = location.href.split('?')[0] + '?' + urlParams;
  //url = "http://10.8.40.164/form/debug/CRC/form_217/index.html?"+ url.split("?")[1];
  if (window.openBdpt && pageName === "employee-other-fee") {
    url = "http://10.0.99.238:8080/platform/online/UAT/CRC/form_217/index.html?" + url.split("?")[1];
  }
  if (pageName === "vendor-advance-charge") {
    url = "http:" + url.split(":")[1] + ":8080/ems/platform/online/UAT/XARL/form_253/index.html?" + url.split("?")[1];
  }
  if (pageName === "temporary-borrowing") {
    url = "http:" + url.split(":")[1] + ":8080/ems/platform/online/UAT/XARL/form_242/index.html?" + url.split("?")[1];
  }
  if (pageName === "travel-fee-before") {
    url = "http:" + url.split(":")[1] + ":8080/ems/platform/online/UAT/XARL/form_257/index.html?" + url.split("?")[1];
  }
  //|| $store.state.reimburseComment.vm.loginInfo.userCode
  //$store.state.userInfo.userCode ||
  let targetUrl = `${url}&singlePage=${singlePage}&pageName=${pageName}&claimId=${data.claimId || data.processVariables[0].formInstId}&procInstId=${data.procesInstanceID}&claimNo=${data.claimNo}&&categoryName=${data.categoryName}&taskNodeType=${data.taskNodeType}&catalogyCode=${data.catalogyCode}&currentTaskId=${currentTaskId}&taskDefinitionKey=${taskDefinitionKey}&currentNodeName=${currentNodeName}&userCode=${
    util.openTaskParams().userCode || ''}&startUserCode=${startUserCode}&actionType=${data.actionType}&fromPendingRead=${data.fromPendingRead}&fromPendingFeedBack=${data.fromPendingFeedBack}`;
  /*	if (data.actID && targetUrl.indexOf("&actId=") > -1) {
    var regExp=/\actId=.*?\&/;
          targetUrl = targetUrl.replace(regExp,data.actID)
  } */
  if (data.actID && targetUrl.indexOf("&actId=") < 0) {
    targetUrl = targetUrl +
      `&actId=${data.actID}`
  }
  if (data.openMode && targetUrl.indexOf("&openMode=") < 0) {
    targetUrl = targetUrl +
      `&openMode=${data.openMode}`
  }
  if (data.fromPendingFeedBack == 'Y' || data.fromAlreadyFeedBack == 'Y') {
    targetUrl = targetUrl +
      `&feedBackCreateUserCode=${data.feedBackCreateUserCode}&feedBackCreateUserName=${data.feedBackCreateUserName}&feedBackId=${data.id}`
  }

  if (data.fromPendingRead == 'Y' || data.fromAlreadyRead == 'Y') {
    targetUrl = targetUrl +
      `&readId=${data.id}`
  }

  if (data.source) {
    targetUrl = targetUrl +
      `&source=${data.source}`
  }
  if (pageName = 'create-payment-apply') {
    targetUrl = targetUrl +
      `&showPayment=true`
  }
  targetUrl = targetUrl + `&crctoken=${sessionStorage.crctoken || sessionStorage.token}`
  if (data.isSubmit) {
    window.win_num = window.win_num + 1;
    window.location.replace(targetUrl);
    window.location.href = targetUrl;
    // window.location.replace(targetUrl);
    //window.win_Array[window.win_num] = window.location.replace(targetUrl);
    //window.location.reload();
  } else {
    window.win_num = window.win_num + 1;
    window.win_Array[window.win_num] = window.open(targetUrl);
  }

}

//也是打开新页面要用到的方法
util.getOrigin = function () {
  let origin = "";
  if (location.origin != location.href.split('/#')[0]) {
    origin = location.href.split('/#')[0];
  } else {
    origin = location.origin;
  }
  return origin
}

//打开页面专属获取地址栏参数
util.openTaskParams = function (url) {
  const uri = url || location.href
  if (uri.indexOf("?") > 0) {
    var params = uri.split("?")[1].split("&");
    var obj = {};
    params.map(v => obj[v.split("=")[0]] = v.split("=")[1]);
    return obj;
  } else {
    return {};
  }
}

// 计算字符数  中2英1数1
util.getByteLen = function (val) {
  var len = 0;
  for (var i = 0; i < val.length; i++) {
    var a = val.charAt(i);
    if (a.match(/[^\x00-\xff]/ig) != null) {
      len += 2;
    } else {
      len += 1;
    }
  }
  return len;
}

// 关闭当前页面用到的方法
util.closeWebPage = function (val) {
  if (navigator.userAgent.indexOf("MSIE") > 0) {
    if (navigator.userAgent.indexOf("MSIE 6.0") > 0) {
      window.opener = null;
      window.close();
    } else {
      window.open('', '_top');
      window.top.close();
    }
  } else if (navigator.userAgent.indexOf("Firefox") > 0) {
    window.open("about:blank", "_self").close();
  } else {
    window.open("about:blank", "_self").close();
  }
}


export default util

