const path = require('path');
//const CopyWebpackPlugin = require('copy-webpack-plugin')
const envConfig = require('./config.json')[process.env.VUE_APP_ENV || 'prd'];

function resolve(dir) {
  return path.join(__dirname, dir);
}

console.log("process.env.VUE_APP_ENV", process.env.VUE_APP_ENV)
// function npmConfArgv() {
//   const argv = JSON.parse(process.env.npm_config_argv)
//   console.log(argv)
//   const config = {};
//   let idx = 2;
//   const cooked = argv.cooked;
//   const length = cooked.length;
//   while ((idx += 2) <= length) {
//     config[cooked[idx - 2]] = cooked[idx - 1];
//   }
//   return config
// }

// const localBuildEnv = npmConfArgv()['--']
// console.log("localBuildEnv", localBuildEnv)

let host = envConfig.host
// let host = 'http://10.0.99.238:7078'
module.exports = {
  lintOnSave: false,
  publicPath: process.env.NODE_ENV === 'production' ? '/form_wallet_web/' : '/',  // 设置部署应用包时的基本URL
  productionSourceMap: false, //更改为false
  assetsDir: 'static',
  // outputDir: path.resolve(__dirname, localBuildEnv ? `./dist_${localBuildEnv}` : './dist'),
  pages: {
    index: {
      entry: './src/main.js',
      template: './src/template/index.ejs',
      filename: 'index.html',
      favicon: './favicon.ico',
      title: '表单',
      chunks: ['chunk-vendors', 'chunk-common', 'index']
    }
  },
  css: {
    loaderOptions: {
      less: {
        javascriptEnabled: true,
        resources: [path.resolve(__dirname, './src')]
      }
    }
  },
  devServer: {
    disableHostCheck: true,
    port: 8088,
    host: '0.0.0.0',
    https: false,
    hotOnly: true,
    proxy: {
      '/': {
        target: host + '/',
        secure: false,
        changeOrigin: true,
        pathRewrite: {
          '^/': ''
        }
      },
      // '/ems-base-application/mams/sys/login': {
      //   target: host + '/',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/': ''
      //   }
      // },
      // '/admin': {
      //   target: host + '/',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/': ''
      //   }
      // },
      // '/ems-mobile-service/*': {
      //   target: 'http://10.0.99.238:8080' + '/',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/': ''
      //   }
      // },
      // "/ems-mobile/*": {
      //   target: 'http://10.0.99.238:8080',
      //   secure: false,
      //   changeOrigin: true
      // },
      // '/ems': {
      //   target: host + '/ems',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/ems': ''
      //   }
      // },

      // // ems_web登录
      // '/ems/mams-rest/sys/login': {
      //   target: 'http://10.0.99.238:8080/ems/mams-rest/sys/login',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/ems/mams-rest/sys/login': ''
      //   }
      // },
      // // ems_admin登录
      // '/admin/mams-rest/sys/login': {
      //   target: 'http://10.0.99.238:8080/admin/mams-rest/sys/login',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/admin/mams-rest/sys/login': ''
      //   }
      // },
      // '/ems-base-application': {
      //   target: 'http://10.0.173.51:7079/ems-base-application',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/ems-base-application': ''
      //   }
      // },
      // '/ems-budget': {
      //   target: 'http://10.0.99.238:8080/admin/ems-budget',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/ems-budget': ''
      //   }
      // },
      // '/system': {
      //   target: 'http://10.0.99.238:8080/admin/system',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/system': ''
      //   }
      // },
      // '/ems-mobile-service/ems-mobile': {
      //   target: 'http://10.0.99.238:8080/admin/ems-mobile-service/ems-mobile',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/ems-mobile-service/ems-mobile': ''
      //   }
      // },
      // '/ems-process-service': {
      //   target: 'http://10.0.99.238:8080/admin/ems-process-service',
      //   secure: false,
      //   changeOrigin: true,
      //   pathRewrite: {
      //     '^/ems-process-service': ''
      //   }
      // }

    }
  },
  chainWebpack: (config) => {
    // 修改文件引入自定义路径
    config.resolve.alias
      .set('@', resolve('./src'))
      .set('@components', resolve('./src/components'))
      .set('@views', resolve('./src/views'))
      .set('@assets', resolve('./src/assets'))
      // .set('@walletstatic', resolve('public/static'))
      // .set('@static', resolve('static'))

    // 输出文件加hash
    config.output.filename('[name].[hash].js').end();
  },
  parallel: require('os').cpus().length > 1, // 构建时开启多进程处理babel编译
  configureWebpack: config => {
    config.externals = {
      // BMap: 'BMap'   // 忽略打包的第三方库
    }
    if (process.env.VUE_APP_ENV == "dev") {
      config.devtool = 'eval-source-map';
    }
    // config.plugins = [new CopyWebpackPlugin([{
    //   from: path.resolve(__dirname, "../static"),
    //   to: "static",
    //   ignore: [".*"]
    // }])]
    // const plugins = [];
    // plugins.push(new CopyWebpackPlugin([{
    //   from: path.resolve(__dirname, "../static"),
    //   to: "static",
    //   ignore: [".*"]
    // }]))
    // config.plugins = []
  },
  transpileDependencies: [
    'iview',
    'ems-components-new'
  ]
};
